/* smilieCommon.js
Author: Christian Wolf, 2005

This file is licensed under the terms and conditions of the GNU General Public License, Version 2.0
*/
var prefService, prefBranch, strbundle, fileHandler, pattern;

function Init(){
	/* initialize and load Preferences */
	strbundle = document.getElementById("strings");
	prefService = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService);
	fileHandler = Components.classes['@mozilla.org/network/protocol;1?name=file'].createInstance(Components.interfaces.nsIFileProtocolHandler);
	prefBranch = prefService.getBranch('smilie.');
	
	/* prepare file type pattern */
	var types = prefBranch.getCharPref('file_types');
	var type_array = types.split(',');
	for (var i = 0; i < type_array.length; i++){
		type_array[i] = '\.' + type_array[i] + '$';
	}
	pattern = new RegExp(type_array.join('|'), 'i');
}

function chooseDir(){
	/* Init */
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes['@mozilla.org/filepicker;1'].createInstance(nsIFilePicker);
	var title = strbundle.getString('chooseDir');
	fp.init(window, title, nsIFilePicker.modeGetFolder);
	
	/* Set up old dir */
	var olddir = prefBranch.getCharPref('curdir');
	if (olddir != ''){
		var odir = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
		odir.initWithPath(olddir);
		fp.displayDirectory = odir.parent;
	}
	
	/* Display the dialog */
	var res = fp.show();
	if (res == nsIFilePicker.returnOK){
		var dir = fp.file;
		if (dir.isDirectory()){
			return dir;
		}
	}
	/* Something went wrong ... */
	return false;
}