/* smilieDialog.js
Author: Christian Wolf, 2005

This file is licensed under the terms and conditions of the GNU General Public License, Version 2.0
*/
function Startup(){
	Init();
	/* init with dir if set */
	var defaultDir = prefBranch.getCharPref('curdir');
	if (defaultDir != ''){
		var dir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		dir.initWithPath(defaultDir);
		if (dir.isDirectory()){
			loadImages(dir);
		}
	}
}

function insertSmilie(img_id){
	var editor = GetCurrentEditor();
	/* create new element */
	imageElement = editor.createElementWithDefaults('img');
	if (!imageElement ){
      dump("Failed to create element!\n");
      window.close();
      return;
    }
	
	/* copy element values */
	var src = document.getElementById(img_id).src;
	imageElement.setAttribute('src', src);
	editor.insertElementAtSelection(imageElement, true);
	window.close();
}

function changeDir(){
	if (dir = chooseDir()){
		/* update preferences */
		prefBranch.setCharPref('curdir', dir.path);
		loadImages(dir);
	}
}

function setWindowSize(){
	window.sizeToContent();
}

function loadImages(dir){
	if (!dir.isDirectory()){
		return false;
	}
	document.getElementById('smilie_folder').value = dir.path;
	var grid = document.getElementById('smilieList');
	/* empty the grid */
	while (grid.hasChildNodes()){
		grid.removeChild(grid.firstChild);
	}
	
	/* first the columns */
	var columns = document.createElement('columns');
	/* TODO: make this variable */
	for (var i = 0; i < 8; i++){
		var column = document.createElement('column');
		column.setAttribute('flex', '1');
		columns.appendChild(column);
	}
	grid.appendChild(columns);
	
	/* insert elements */
	var rows = document.createElement('rows');
	var nimg = 0;
	var files = dir.directoryEntries;
	var row;
	while (files.hasMoreElements()){
		var file = files.getNext();
		/* Sanity - and cast */
		if (! (file instanceof Components.interfaces.nsILocalFile)){
			continue;
		}
		
		/* check if file type supported / wanted */
		var fname = file.leafName;
		if (! pattern.test(fname)){
			continue;
		}
		
		/* TODO: make this variable */
		if ((nimg++ % 8) ==  0){
			row = document.createElement('row');
			row.setAttribute('flex', 1);
			rows.appendChild(row);
		}
		var box = document.createElement('box');
		box.setAttribute('class', 'smilie-image-box');
		var img = document.createElement('image');
		var id = 'img' + nimg;
		img.setAttribute('id', id);
		img.setAttribute('validate', 'always');
		img.setAttribute('src', fileHandler.getURLSpecFromFile(file));
		img.setAttribute('onclick', 'insertSmilie(\'' + id + '\');');
		/* A little hack: resize when image has finished loading
			There has to be a better way to do this */
		img.setAttribute('onload', 'setWindowSize();');
		box.appendChild(img);
		row.appendChild(box);
	}
	grid.appendChild(rows);
}